/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.18_02 from the
 * contents of LZO.xs. Do not edit this file, edit LZO.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "LZO.xs"
/* LZO.xs -- Perl bindings for the LZO data compression library

   This file is part of the LZO real-time data compression library.

   Copyright (C) 2002 Markus Franz Xaver Johannes Oberhumer
   Copyright (C) 2001 Markus Franz Xaver Johannes Oberhumer
   Copyright (C) 2000 Markus Franz Xaver Johannes Oberhumer
   Copyright (C) 1999 Markus Franz Xaver Johannes Oberhumer
   Copyright (C) 1998 Markus Franz Xaver Johannes Oberhumer
   All Rights Reserved.

   The LZO library is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of
   the License, or (at your option) any later version.

   The LZO library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with the LZO library; see the file COPYING.
   If not, write to the Free Software Foundation, Inc.,
   59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   Markus F.X.J. Oberhumer
   <markus@oberhumer.com>
   http://www.oberhumer.com/opensource/lzo/
 */


#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <lzoconf.h>
#include <lzo1x.h>

#if !defined(LZO_VERSION) || (LZO_VERSION < 0x1070)
#  error "Need LZO v1.07 or newer"
#endif

#undef UNUSED
#define UNUSED(x)       ((void)&x)


/* If the buffer is a reference, dereference it */
static SV *deRef(SV *sv, const char *method)
{
	SV *last_sv = NULL;
	while (SvROK(sv) && sv != last_sv)
	{
		last_sv = sv;
		sv = SvRV(sv);
	}
	if (!SvOK(sv))
		croak("Compress::LZO::%s: buffer parameter is not a SCALAR", method);
	return sv;
}


static double constant(const char *name, int arg)
{
    UNUSED(name);
    UNUSED(arg);
	errno = EINVAL;
	return 0;
}


/***********************************************************************
// XSUB start
************************************************************************/

#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#line 90 "LZO.c"
#define X_LZO_VERSION()         lzo_version()

XS(XS_Compress__LZO_LZO_VERSION); /* prototype to pass -Wmissing-prototypes */
XS(XS_Compress__LZO_LZO_VERSION)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Compress::LZO::LZO_VERSION", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	unsigned	RETVAL;
	dXSTARG;

	RETVAL = X_LZO_VERSION();
	XSprePUSH; PUSHu((IV)RETVAL);
    }
    XSRETURN(1);
}

#define X_LZO_VERSION_STRING()  (const char *)lzo_version_string()

XS(XS_Compress__LZO_LZO_VERSION_STRING); /* prototype to pass -Wmissing-prototypes */
XS(XS_Compress__LZO_LZO_VERSION_STRING)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Compress::LZO::LZO_VERSION_STRING", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	const char *	RETVAL;
	dXSTARG;

	RETVAL = X_LZO_VERSION_STRING();
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}

#define X_LZO_VERSION_DATE()    (const char *)lzo_version_date()

XS(XS_Compress__LZO_LZO_VERSION_DATE); /* prototype to pass -Wmissing-prototypes */
XS(XS_Compress__LZO_LZO_VERSION_DATE)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Compress::LZO::LZO_VERSION_DATE", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	const char *	RETVAL;
	dXSTARG;

	RETVAL = X_LZO_VERSION_DATE();
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Compress__LZO_constant); /* prototype to pass -Wmissing-prototypes */
XS(XS_Compress__LZO_constant)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Compress::LZO::constant", "name, arg");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	const char *	name = (const char *)SvPV_nolen(ST(0));
	int	arg = (int)SvIV(ST(1));
	double	RETVAL;
	dXSTARG;

	RETVAL = constant(name, arg);
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Compress__LZO_compress); /* prototype to pass -Wmissing-prototypes */
XS(XS_Compress__LZO_compress)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Compress::LZO::compress", "string, level = 1");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 111 "LZO.xs"
		SV *       sv;
		STRLEN     len;
		int        level = 1;
		lzo_bytep  in;
		lzo_bytep  out;
		lzo_voidp  wrkmem;
		lzo_uint   in_len;
		lzo_uint   out_len;
		lzo_uint   new_len;
		int        err;
#line 208 "LZO.c"
	SV *	RETVAL;
#line 122 "LZO.xs"
		sv = deRef(ST(0), "compress");
		in = (lzo_bytep) SvPV(sv, len);
		if (items == 2 && SvOK(ST(1)))
			level = SvIV(ST(1));
		in_len = len;
		out_len = in_len + in_len / 64 + 16 + 3;
		RETVAL = newSV(5+out_len);
		SvPOK_only(RETVAL);
		if (level == 1)
			wrkmem = safemalloc(LZO1X_1_MEM_COMPRESS);
		else
			wrkmem = safemalloc(LZO1X_999_MEM_COMPRESS);
		out = SvPVX(RETVAL);
		new_len = out_len;
		if (level == 1)	{
			out[0] = 0xf0;
			err = lzo1x_1_compress(in,in_len,out+5,&new_len,wrkmem);
		} else {
			out[0] = 0xf1;
			err = lzo1x_999_compress(in,in_len,out+5,&new_len,wrkmem);
		}
		safefree(wrkmem);
		if (err != LZO_E_OK || new_len > out_len)
		{
			SvREFCNT_dec(RETVAL);
			XSRETURN_UNDEF;
		}
		SvCUR_set(RETVAL,5+new_len);
		out[1] = (in_len >> 24) & 0xff;
		out[2] = (in_len >> 16) & 0xff;
		out[3] = (in_len >>  8) & 0xff;
		out[4] = (in_len >>  0) & 0xff;
#line 243 "LZO.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Compress__LZO_decompress); /* prototype to pass -Wmissing-prototypes */
XS(XS_Compress__LZO_decompress)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Compress::LZO::decompress", "string");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 165 "LZO.xs"
		SV *       sv;
		STRLEN     len;
		lzo_bytep  in;
		lzo_bytep  out;
		lzo_uint   in_len;
		lzo_uint   out_len;
		lzo_uint   new_len;
		int        err;
#line 272 "LZO.c"
	SV *	RETVAL;
#line 174 "LZO.xs"
		sv = deRef(ST(0), "decompress");
		in = (lzo_bytep) SvPV(sv, len);
		if (len < 5 + 3 || in[0] < 0xf0 || in[0] > 0xf1)
			XSRETURN_UNDEF;
		in_len = len - 5;
		out_len = (in[1] << 24) | (in[2] << 16) | (in[3] << 8) | in[4];
		RETVAL = newSV(out_len > 0 ? out_len : 1);
		SvPOK_only(RETVAL);
		out = SvPVX(RETVAL);
		new_len = out_len;
		err = lzo1x_decompress_safe(in+5,in_len,out,&new_len,NULL);
		if (err != LZO_E_OK || new_len != out_len)
		{
			SvREFCNT_dec(RETVAL);
			XSRETURN_UNDEF;
		}
		SvCUR_set(RETVAL, new_len);
#line 292 "LZO.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Compress__LZO_optimize); /* prototype to pass -Wmissing-prototypes */
XS(XS_Compress__LZO_optimize)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Compress::LZO::optimize", "string");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 202 "LZO.xs"
		SV *       sv;
		STRLEN     len;
		lzo_bytep  in;
		lzo_bytep  out;
		lzo_uint   in_len;
		lzo_uint   out_len;
		lzo_uint   new_len;
		int        err;
#line 321 "LZO.c"
	SV *	RETVAL;
#line 211 "LZO.xs"
		sv = deRef(ST(0), "optimize");
		RETVAL = newSVsv(sv);
		SvPOK_only(RETVAL);
		in = (lzo_bytep) SvPV(RETVAL, len);
		if (len < 5 + 3 || in[0] < 0xf0 || in[0] > 0xf1)
		{
			SvREFCNT_dec(RETVAL);
			XSRETURN_UNDEF;
		}
		in_len = len - 5;
		out_len = (in[1] << 24) | (in[2] << 16) | (in[3] << 8) | in[4];
		out = (lzo_bytep) safemalloc(out_len > 0 ? out_len : 1);
		new_len = out_len;
		err = lzo1x_optimize(in+5,in_len,out,&new_len,NULL);
		safefree(out);
		if (err != LZO_E_OK || new_len != out_len)
		{
			SvREFCNT_dec(RETVAL);
			XSRETURN_UNDEF;
		}
#line 344 "LZO.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Compress__LZO_adler32); /* prototype to pass -Wmissing-prototypes */
XS(XS_Compress__LZO_adler32)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Compress::LZO::adler32", "string, adler = adlerInitial");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 242 "LZO.xs"
		SV *       sv;
		STRLEN     len;
		lzo_bytep  buf;
#line 368 "LZO.c"
	lzo_uint32	RETVAL;
	dXSTARG;
#line 246 "LZO.xs"
		sv = deRef(ST(0), "adler32");
		buf = (lzo_bytep) SvPV(sv, len);
		if (items == 2 && SvOK(ST(1)))
			RETVAL = SvUV(ST(1));
		else
			RETVAL = 1;
		RETVAL = lzo_adler32(RETVAL, buf, (lzo_uint)len);
#line 379 "LZO.c"
	XSprePUSH; PUSHu((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Compress__LZO_crc32); /* prototype to pass -Wmissing-prototypes */
XS(XS_Compress__LZO_crc32)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Compress::LZO::crc32", "string, crc = crcInitial");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 260 "LZO.xs"
		SV *       sv;
		STRLEN     len;
		lzo_bytep  buf;
#line 402 "LZO.c"
	lzo_uint32	RETVAL;
	dXSTARG;
#line 264 "LZO.xs"
		sv = deRef(ST(0), "crc32");
		buf = (lzo_bytep) SvPV(sv, len);
		if (items == 2 && SvOK(ST(1)))
			RETVAL = SvUV(ST(1));
		else
			RETVAL = 0;
		RETVAL = lzo_crc32(RETVAL, buf, (lzo_uint)len);
#line 413 "LZO.c"
	XSprePUSH; PUSHu((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Compress__LZO); /* prototype to pass -Wmissing-prototypes */
XS(boot_Compress__LZO)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXSproto("Compress::LZO::LZO_VERSION", XS_Compress__LZO_LZO_VERSION, file, "");
        newXSproto("Compress::LZO::LZO_VERSION_STRING", XS_Compress__LZO_LZO_VERSION_STRING, file, "");
        newXSproto("Compress::LZO::LZO_VERSION_DATE", XS_Compress__LZO_LZO_VERSION_DATE, file, "");
        newXSproto("Compress::LZO::constant", XS_Compress__LZO_constant, file, "$$");
        newXSproto("Compress::LZO::compress", XS_Compress__LZO_compress, file, "$;$");
        newXSproto("Compress::LZO::decompress", XS_Compress__LZO_decompress, file, "$");
        newXSproto("Compress::LZO::optimize", XS_Compress__LZO_optimize, file, "$");
        newXSproto("Compress::LZO::adler32", XS_Compress__LZO_adler32, file, "$;$");
        newXSproto("Compress::LZO::crc32", XS_Compress__LZO_crc32, file, "$;$");

    /* Initialisation Section */

#line 82 "LZO.xs"
	if (lzo_init() != LZO_E_OK)
		croak("Compress::LZO lzo_init() failed\n");

#line 452 "LZO.c"

    /* End of Initialisation Section */

    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

